| Qore Swagger Module Reference 2.0.8

Static Public Member Functions | Public Attributes | Protected Member Functions | List of all members
Swagger::ParameterItemsSchemaObject Class Reference

items schema object for non-body parameters More...

Inheritance diagram for Swagger::ParameterItemsSchemaObject:
[legend]

## Static Public Member Functions
static ParameterItemsSchemaObject | newSchemaObject (string name, auto error, SwaggerSchema swagger)
| throws an `"INVALID-FIELD-TYPE"` exception More...
static ParameterItemsSchemaObject | newSchemaObject (string name, hash< auto > oh, SwaggerSchema swagger)
| returns a SchemaObject for the schema definition; resolves references More...
Static Public Member Functions inherited from Swagger::SchemaObject
static SchemaObject | newSchemaObject (string name, auto error, SwaggerSchema swagger)
| throws an `"INVALID-FIELD-TYPE"` exception More...
static SchemaObject | newSchemaObject (string name, hash< auto > oh, SwaggerSchema swagger)
| returns a SchemaObject for the schema definition; resolves references More...
Static Public Member Functions inherited from Swagger::SchemaBase
static bool | checkValueType (reference< auto > value, string type)
| Checks the value against the type. More...

## Public Attributes
*string | collectionFormat
| Determines the format of the array if type array is used. More...
Public Attributes inherited from Swagger::SchemaObject
auto | additionalProperties
| See https://tools.ietf.org/html/draft-fge-json-schema-validation-00#section-5.4.4. More...
auto | defaultVal
| See https://tools.ietf.org/html/draft-fge-json-schema-validation-00#section-6.2.
*string | desc
| See https://tools.ietf.org/html/draft-fge-json-schema-validation-00#section-6.1.
*string | discriminator
| Adds support for polymorphism. More...
auto | example
| A free-form property to include an example of an instance for this schema.
*ExternalDocumentationObject | externalDocs
| Additional external documentation for this schema.
*string | format
| The extending format for the previously mentioned `type`. See Data Type Formats for further details.
*SchemaObject | items
| See https://tools.ietf.org/html/draft-fge-json-schema-validation-00#section-5.3.1.
*int | maxProperties
| See https://tools.ietf.org/html/draft-fge-json-schema-validation-00#section-5.4.1.
*int | minProperties
| See https://tools.ietf.org/html/draft-fge-json-schema-validation-00#section-5.4.2.
string | name
| the name of this object for documentation and example purposes
bool | nullable = False
| extension that allows types to be nullable More...
hash< string, SchemaObject > | properties
| See https://tools.ietf.org/html/draft-fge-json-schema-validation-00#section-5.4.4. More...
bool | readOnly = False
| Relevant only for Schema `"properties"` definitions. Declares the property as "read only". More...
const | ReferenceTypes = ...
| valid reference types
hash< string, bool > | required
| See https://tools.ietf.org/html/draft-fge-json-schema-validation-00#section-5.4.3. More...
const | ScalarTypes = ...
| valid scalar types
*string | title
| See https://tools.ietf.org/html/draft-fge-json-schema-validation-00#section-6.1.
string | type
| See https://tools.ietf.org/html/draft-fge-json-schema-validation-00#section-5.5.2. More...
*XmlObject | xml
| This MAY be used only on properties schemas. It has no effect on root schemas. More...
Public Attributes inherited from Swagger::ObjectBase
hash< auto > | vendorExtensions
| Allows extensions to the Swagger Schema. More...
Public Attributes inherited from Swagger::SchemaBase
hash< string, bool > | enum
| See https://tools.ietf.org/html/draft-fge-json-schema-validation-00#section-5.5.1. More...
*bool | exclusiveMax
| See https://tools.ietf.org/html/draft-fge-json-schema-validation-00#section-5.1.2.
*bool | exclusiveMin
| See https://tools.ietf.org/html/draft-fge-json-schema-validation-00#section-5.1.3.
*float | maximum
| See https://tools.ietf.org/html/draft-fge-json-schema-validation-00#section-5.1.2.
*int | maxItems
| See https://tools.ietf.org/html/draft-fge-json-schema-validation-00#section-5.3.2.
*int | maxLength
| See https://tools.ietf.org/html/draft-fge-json-schema-validation-00#section-5.2.1.
*float | minimum
| See https://tools.ietf.org/html/draft-fge-json-schema-validation-00#section-5.1.3.
*int | minItems
| See https://tools.ietf.org/html/draft-fge-json-schema-validation-00#section-5.3.3.
*int | minLength
| See https://tools.ietf.org/html/draft-fge-json-schema-validation-00#section-5.2.2.
*float | multipleOf
| See https://tools.ietf.org/html/draft-fge-json-schema-validation-00#section-5.1.1.
*string | pattern
| See https://tools.ietf.org/html/draft-fge-json-schema-validation-00#section-5.2.3.
*bool | uniqueItems
| See https://tools.ietf.org/html/draft-fge-json-schema-validation-00#section-5.3.4.

## Protected Member Functions
| constructor (string name, hash< auto > oh, SwaggerSchema swagger)
| private constructor; use newSchemaObject() instead More...
Protected Member Functions inherited from Swagger::SchemaObject
| checkIntern (bool serialize, bool request, string type, *string format, string path, string method, string name, hash< auto > v, reference< hash< auto >> value)
| validates a schema object against a value
| constructor (string name, hash< auto > oh, SwaggerSchema swagger, *string hash_str)
| private constructor; use newSchemaObject() instead More...
Protected Member Functions inherited from Swagger::SchemaBase
| check (bool serialize, bool request, string type, *string format, *SchemaObject items, string path, string method, string name, reference< auto > value)
| validates the value against the schema definition
| checkArrayParam (bool serialize, bool request, SchemaObject items, string path, string method, string name, reference< softlist< auto >> value)
| validates the value against the schema definition
| checkIntern (bool serialize, bool request, string type, *string format, string path, string method, string name, binary v, reference value)
| converts binary values to strings for supported formats
| checkIntern (bool serialize, bool request, string type, *string format, string path, string method, string name, date v, reference value)
| converts strings to/from date/time values for supported formats
| checkIntern (bool serialize, bool request, string type, *string format, string path, string method, string name, string v, reference< auto > value)
| validates string values
auto | getExampleValue (string type, *string format)
| returns an example value for the given type

## Additional Inherited Members
Public Member Functions inherited from Swagger::SchemaObject
list< SchemaObject > | allOf ()
| See https://tools.ietf.org/html/draft-fge-json-schema-validation-00#section-5.5.3. More...
| check (bool serialize, bool request, string path, string method, string name, reference< auto > value)
| validates the value against the schema definition
string | getQoreExample (reference< hash< RestQoreExampleCodeInfo >> rv, string name, bool decl)
| returns example Qore code for the object
Public Member Functions inherited from Swagger::ObjectBase
| constructor ()
| Constructor.
| constructor (hash< auto > oh)
| Constructor. More...
| constructor (ObjectBase other)
| copy constructor
| initialize (hash< auto > oh)
| Initialize. More...
Public Member Functions inherited from Swagger::SchemaBase
| constructor (SchemaBase other)
| Copy constructor.
| constructor (string objType, hash< auto > oh)
| Constructor. More...
Static Protected Member Functions inherited from Swagger::SchemaObject
static | checkValueType (reference< auto > value, string type, *SchemaObject items, *string loc)
| validates default values
Static Protected Member Functions inherited from Swagger::SchemaBase
static | throwInvalidType (string name, string actual, string expected, auto value)
| throws an `SCHEMA-VALIDATION-ERROR` exception

## Detailed Description

items schema object for non-body parameters

## Member Function Documentation

## ◆ constructor()

Swagger::ParameterItemsSchemaObject::constructor | ( | string | name,
|  | hash< auto > | oh,
|  | SwaggerSchema | swagger
| ) |  |
| protected

private constructor; use newSchemaObject() instead

Parameters

  name | the name of the object
  oh | deserialized hash from the source schema description describing an object in the schema
  swagger | the REST schema for resolving references

Exceptions

  INVALID-FIELD-FORMAT | field has invalid format
  INVALID-FIELD-TYPE | field has invalid type
  INVALID-FIELD-VALUE | field has invalid value
  INVALID-COLLECTION-FORMAT | invalid collectionFormat value
  INVALID-REFERENCE | cannot resolve reference; unknown attributes in description
  REQUIRED-FIELD-MISSING | required field is missing

## ◆ newSchemaObject() [1/2]

static ParameterItemsSchemaObject Swagger::ParameterItemsSchemaObject::newSchemaObject | ( | string | name,
|  | auto | error,
|  | SwaggerSchema | swagger
| ) |  |
| static

throws an `"INVALID-FIELD-TYPE"` exception

Exceptions

  INVALID-FIELD-TYPE | due to a type error in the call

## ◆ newSchemaObject() [2/2]

static ParameterItemsSchemaObject Swagger::ParameterItemsSchemaObject::newSchemaObject | ( | string | name,
|  | hash< auto > | oh,
|  | SwaggerSchema | swagger
| ) |  |
| static

returns a SchemaObject for the schema definition; resolves references

Parameters

  name | the name of the object
  oh | deserialized hash from the source schema description describing an object in the schema
  swagger | the REST schema for resolving references

Exceptions

  INVALID-FIELD-FORMAT | field has invalid format
  INVALID-FIELD-TYPE | field has invalid type
  INVALID-FIELD-VALUE | field has invalid value
  INVALID-COLLECTION-FORMAT | invalid collectionFormat value
  INVALID-REFERENCE | cannot resolve reference; unknown attributes in description
  REQUIRED-FIELD-MISSING | required field is missing

## Member Data Documentation

## ◆ collectionFormat

*string Swagger::ParameterItemsSchemaObject::collectionFormat

Determines the format of the array if type array is used.

Possible values are:

- `"csv"`: comma separated values; ex: foo,bar
- `"ssv"`: space separated values; ex: foo bar
- `"tsv"`: tab separated values; ex: foo\tbar
- `"pipes"`: pipe separated values; ex: foo|bar
- `"multi"`: corresponds to multiple parameter instances instead of multiple values for a single instance `foo=bar&foo=baz`. This is valid only for parameters in `"query"` or `"formData"`.

Default value is `"csv"`.